<template>
    <form class="form"
          novalidate
          @submit.prevent="handleSubmit">
        <Fieldset title="Ajouter un utilisateur">
                <FormInput v-model="member.LastName"
                           type="text"
                           name="nom"
                           :ref="addFormInputRef"
                           :label="t(`utilisateur.nom`)"
                           @validated="handleValidation" />
                <FormInput v-model="member.FirstName"
                           type="text"
                           name="prenom"
                           :ref="addFormInputRef"
                           :label="t(`utilisateur.prenom`)"
                           @validated="handleValidation" />

                <FormInput v-model="member.Email"
                           type="text"
                           name="email"
                           :ref="addFormInputRef"
                           :label="t(`utilisateur.courriel`)"
                           @validated="handleValidation" />

                <FormInput v-model="member.password"
                           type="password"
                           name="motDePasse"
                           :ref="addFormInputRef"
                           :label="t(`utilisateur.motDePasse`)"
                           @validated="handleValidation" />
                <FormInput v-model="passwd2"
                           type="password"
                           name="confirmationMotDePasse"
                           :ref="addFormInputRef"
                           :label="t(`utilisateur.confirmationMotDePasse`)"
                           @validated="handleValidation" />
                <FormCheckbox name="adminCheckbox" 
                              v-model="EstAdmin"
                              model-value="false" 
                              :ref="addFormInputRef"
                              :label="t(`utilisateur.admin`)" 
                              />
        </Fieldset>


        <button class="form__submit btn btn--fullscreen" type="submit">
            {{ t("global.add") }}
        </button>
    </form>
</template>

<script lang="ts" setup>
    import { ref } from 'vue'
    import { Utilisateur } from '../../types/entities/utilisateur'
    import { Member } from '../../types/entities'
    import { useRouter } from "vue-router";
    import { notifyError, notifySuccess } from "@/notify";
    import FormInput from "@/components/forms/FormInput.vue";
    import Fieldset from "@/components/forms/Fieldset.vue";
    import FormRow from "@/components/forms/FormRow.vue";
    import FormFiles from "@/components/forms/FormFiles.vue";
    import { Product } from "@/types/entities/product";
    import FormTextEditor from "@/components/forms/FormTextEditor.vue";
    import { useUtilisateurService } from "@/inversify.config";
    import { ICreateUtilisateurRequest } from '../../types/requests'
    import { Status } from "@/validation";
    import { useI18n } from "vue3-i18n";
import { RefSymbol } from '@vue/reactivity';
    import FormCheckbox from "@/components/forms/FormCheckbox.vue";
    const { t } = useI18n()
    const passwd2 = ref<string>("")
    const EstAdmin = ref<boolean>(false)
    

// eslint-disable-next-line no-undef
const props = defineProps<{
    member?: Member
}>()

// eslint-disable-next-line
const emit = defineEmits<{
    (event: "formSubmit", member: Member): void
}>()


const member = ref<Member>(props.member ?? {})

const formInputs = ref<any[]>([])
const inputValidationStatuses:any = {}

function addFormInputRef(ref: typeof FormInput) {
    if (!formInputs.value.includes(ref) && ref)
        formInputs.value.push(ref)
}

async function handleValidation(name: string, validationStatus: Status) {
    inputValidationStatuses[name] = validationStatus.valid
}

async function handleSubmit() {
    formInputs.value.forEach((x: typeof FormInput) => x.validateInput())
    console.log(EstAdmin.value)
    if (member.value.password != passwd2.value) {
      notifyError(t('validation.member.add.invalidPasswordConfirmation'))
      return;
    }
    if (EstAdmin.value) {
        member.value.IsAdmin = true
    }
    else {
        member.value.IsAdmin = false
    }
    
    if (Object.values(inputValidationStatuses).some(x => x === false)) {
        console.log(member.value)
        notifyError(t('global.formErrorNotification'))
        return
    }
    console.log(member.value)
    emit("formSubmit", member.value)
}
   

</script>